#include <stdio.h>
#include <stdlib.h>
#include <set>

using namespace std;

long long M[2005][2005];
set<long long>a,b;

int main()
{
 int N;
 long K;
 int i,j;
 int v1,v2,bp=0;
 
 scanf("%d%ld",&N,&K);
 
 for(i=0;i<N;i++)
  for(j=0;j<N;j++) scanf("%lld",&M[i][j]);
  
 for(i=0;i<N;i++)
  for(j=0;j<N;j++) 
  {
/*
                   v1=b.size();
                   b.insert(M[i][j]);
                   v2=b.size();
                   if(v2>v1) bp-1;
*/                   
   v1=a.size();
   a.insert(M[i][j]);
   v2=a.size();
   if(v1==v2)
   {
    if(i>0 && j==0)
    if(M[i-1][j]==M[i][j]) continue;
    else
    {
     v1=b.size();
     b.insert(M[i][j]);
     v2=b.size();
     if(v2>v1) bp-=1;
    }
    if(i==0 && j>0)
    if(M[i][j-1]==M[i][j]) continue;
    else
    {
     v1=b.size();
     b.insert(M[i][j]);
     v2=b.size();
     if(v2>v1) bp-=1;
    }
    if(i>0 && j>0)
        if(M[i-1][j]==M[i][j])
             if(M[i][j-1]==M[i][j])
                  if(M[i-1][j-1]==M[i][j]) continue;
                  else
                  {
                   v1=b.size();
                   b.insert(M[i][j]);
                   v2=b.size();
                   if(v2>v1) bp-=1;
                  }
             else
                  if(M[i-1][j-1]==M[i][j])
                  {
                   v1=b.size();
                   b.insert(M[i][j]);
                   v2=b.size();
                   if(v2>v1) bp-=1;
                  }
                  else continue;
        else
            if(M[i][j-1]==M[i][j])
            {
                 if(M[i-1][j-1]==M[i][j])
                 {
                  v1=b.size();
                  b.insert(M[i][j]);
                  v2=b.size();
                  if(v2>v1) bp-=1;
                 }
                 else continue;
            }
            else
            {
             v1=b.size();
             b.insert(M[i][j]);
             v2=b.size();
             if(v2>v1) bp-=1;
            }
   }
   else bp++;
   
//   printf("(%d,%d): %d|%lld\n",i,j,bp,M[i][j]);   
   
  }
 
 printf("%d",bp);
 
 return 0;
}